			TITLE KIKO.ASM
;                      Resources Dumper
; -------------------------------------------------------------------------
	.386
	.model flat, stdcall
; -------------------------------------------------------------------------
	include windows.inc
	include kernel32.inc
	include user32.inc
	include gdi32.inc
        include comdlg32.inc
	include comctl32.inc

	includelib kernel32.lib
	includelib user32.lib
	includelib gdi32.lib
        includelib comdlg32.lib
	includelib comctl32.lib
; -----------------------------------------------------------------------

RESOURCE_TYPE struct
	ResType	 	dw ?
	uRes	 	dw ?
	pResInfo 	dd ?
RESOURCE_TYPE ends


RESOURCE_TYPE_ENTRY struct
	IDR	 	dw ?
	Reserved        dw ?
	ItemOffset	dd ?
	@VA		dd ?
	ItemSize	dd ?
RESOURCE_TYPE_ENTRY ends


RESOURCE_TYPE_NUMBER struct
	NamedEntries	dw ?
	IdEntries	dw ?
	EntriesNumber	dd ?
RESOURCE_TYPE_NUMBER ends

; --------------------------------------------------------------------------

; ---------------------------
; Structures of RT_GROUP_ICON
; ---------------------------

GRPICONDIRENTRY struct
bWidth        BYTE ?  ; Width, in pixels, of the image
bHeight       BYTE ?  ; Height, in pixels, of the image
bColorCount   BYTE ?  ; Number of colors in image (0 if >=8bpp)
bReserved     BYTE ?  ; Reserved
wPlanes       WORD ?  ; Color Planes
wBitCount     WORD ?  ; Bits per pixel
dwBytesInRes  DWORD ? ; how many bytes in this resource?
nID           WORD ?  ; the ID
GRPICONDIRENTRY  ends

GRPICONDIR	struct
idReserved	dw ?	; Reserved (must be 0)
idType		dw ?	; Resource type (1 for icons)
idCount		dw ?	; How many images?
idEntries	GRPICONDIRENTRY <?>	; // The entries for each image
GRPICONDIR	ends

; ---------------------------
; Structures of RT_ICON
; ---------------------------

ICONDIRENTRY struct
    BYTE        bWidth;          // Width, in pixels, of the image
    BYTE        bHeight;         // Height, in pixels, of the image
    BYTE        bColorCount;     // Number of colors in image (0 if >=8bpp)
    BYTE        bReserved;       // Reserved ( must be 0)
    WORD        wPlanes;         // Color Planes
    WORD        wBitCount;       // Bits per pixel
    DWORD       dwBytesInRes;    // How many bytes in this resource?
    DWORD       dwImageOffset;   // Where in the file is this image?
ICONDIRENTRY ends

ICONDIR struct
idReserved	WORD	? ; Reserved (must be 0)
idType		WORD	? ; Resource Type (1 for icons)
idCount		WORD	? ; How many images?
idEntries       ICONDIRENTRY <?> ; An entry for each image (idCount of 'em)
ICONDIR ends

; --------------------------------------------------------------------------

	.data?
hMod		dd	?
hFile		dd	?

pMem1		dd	?
pMem2		dd	?
pFile		dd	?

pResSection	dd	?
pResSect	dd	?

NumberOfSections_	dd	?
ImageBase_		dd	?

FileName	db	256	dup	(?)
buffer		db	256	dup	(?)

ofn		OPENFILENAME		<>
rt		RESOURCE_TYPE		<>
rte		RESOURCE_TYPE_ENTRY	<>
rtn		RESOURCE_TYPE_NUMBER 	<>

_404412h	dd	8	dup	(?)
flag_0		dd	?
hMainDlg	dd	?
unk_404498	dd	?

; --------------------------------------------------------------------------

	.data
CaptionStr	db	'ResDumper by   n u M I T_o r', 0

Msg00		db	'Can not open the file :_(', 0
Msg01		db	'Is nor a executable file :- (', 0
Msg02		db	'Is not a PE file', 0
Msg03		db	'The resource has been dumped ;-)', 0
Msg04		db	' ', 0
Msg05		db	' ', 0

StrMenu1	db	'Dump resource', 0
StrMenu2	db	'Dump .ico file', 0
Filter		db	'*.exe, *.dll', 0, '*.exe; *.dll', 0, 0
filter2		db 	'Icon files  (*.ico)', 0, '*.ico', 0, 0
IcoExt		db	"ico", 0


template1	db '%d',0
template2	db '%08lX',0

OldProcStr	db "oldproc", 0 

		db  "Cancel", 0  

Dlgname  	db  "TreeDlg", 0  
Str00           db  "Dump Resource", 0  

; --------------------------------------------------------------------------

	.code
start:		push	0
		call	GetModuleHandleA
		mov	hMod, eax

		push	eax
		
		push	0
		push	offset KikoDlgProc
		push	0
		push	10000
		push	eax
		call	DialogBoxParam

		push	pFile
		call	UnmapViewOfFile

		push	8000h
		push	0
		push	pMem1
		call	VirtualFree

		push	8000h
		push	0
		push	pMem2
		call	VirtualFree

		call	ExitProcess
		call	InitCommonControls


;

KikoDlgProc:	push	ebp
		mov	ebp, esp
		add	esp, 0FFFFFEC8h

		push	edi
		push	esi
		push	ebx

		mov	eax, [ebp+0Ch]
		cmp	eax, WM_INITDIALOG
		jnz	loc_401520
; ==================================
; Process the WM_INITDIALOG message
; Procesar el mensaje WM_INITDIALOG
; ==================================
; ----------------------------------
; To fill OPENFILENAME struct
; Llenar la estructura OPENFILENAME
; ----------------------------------
		lea  edi, FileName
		mov  ofn.lStructSize, SIZEOF ofn
		push hMainDlg
		pop  ofn.hwndOwner
		push hMod
		pop  ofn.hInstance
		mov  ofn.lpstrFile, edi 
		mov  ofn.nMaxFile, 256
		mov  ofn.Flags, OFN_EXPLORER or OFN_LONGNAMES or OFN_HIDEREADONLY
		mov  ofn.lpstrTitle, 0
		mov  ofn.lpstrFilter, offset Filter

		call	ZeroBuffer
; -----------------------
; Select a file
; Seleccionar un archivo
; -----------------------
		push	offset ofn
		call	GetOpenFileNameA
		or	eax, eax
		jnz	loc_401142

a00:            push    0
		push	dword ptr [ebp+8]
		call	EndDialog
		jmp	ret_fals

; --------------------------------------------
; Unmap old file
; Desproyectar el archivo anterior, si lo hay
; --------------------------------------------
loc_401142:     cmp	pFile, 0
		jz	loc_401156
		push	pFile
		call	UnmapViewOfFile
; -----------------
; Open the file
; Abrir el archivo
; -----------------
loc_401156:	push	0
		push	0
		push	3
		push	0
		push	3
		push	0C0000000h
		push	edi
		call	CreateFileA
		cmp	eax, 0FFFFFFFFh
		jnz	loc_40118D

a01:		push	30h
		push	offset CaptionStr
		push	offset Msg00		; Can not open
		push	0
		call	MessageBoxA
		jmp	a00

; ------------------------------------------------------
; Create a object file mapping
; Crear un objeto de proyeccin para el archivo abierto
; ------------------------------------------------------
loc_40118D:	push	eax
		xor	ebx, ebx
		push	ebx
		push	ebx
		push	ebx
		push	4
		push	ebx
		push	eax
		call	CreateFileMappingA
		mov	[ebp-8], eax
		call	CloseHandle
; --------------------------------
; Map a view of file
; Proyectar una vista del archivo
; --------------------------------
		push	ebx
		push	ebx
		push	ebx
		push	6
		push	[ebp-8]
		call	MapViewOfFile
		mov	edi, eax
; ------------------------------
; Has been maped a file?
; Ha sido proyectado el archivo
; ------------------------------
		push	[ebp-8]
		call	CloseHandle
; -------------------------
; Is a exe file?
; Es un archivo ejecutable
; -------------------------
		or	edi, edi
		jz	a01

		cmp	word ptr [edi],	5A4Dh
		jz	loc_40121B
; -----------------
; Is not a exe file
; Si no lo es salir
; -----------------
loc_4011E6:
		push	30h 
		push	offset CaptionStr
		push	offset Msg01		; Not exe file
		push	dword ptr [ebp+8]
		call	MessageBoxA
		push	edi
		call	UnmapViewOfFile
		jmp 	a00

;  ----------------------------------------------------------

loc_40121B:
; ----------------------------
; Is a exe file. Is a pe file?
; Es un archivo pe?
; ----------------------------
		mov	pFile, edi
		add	edi, dword ptr [edi+3Ch]
		mov	esi, edi
		lodsw
		cmp	ax, 4550h
		jz	loc_401264

		push	30h
		push	offset CaptionStr
		push	offset Msg02		; Not pe file
		push	dword ptr [ebp+8]
		call	MessageBoxA
		push	pFile
		call	UnmapViewOfFile
		jmp	a00

      ; ----------------- GET PE FILE INFO -------------------

; --------------------------------------------------
; Is a pe file. Get the number of sections
; Es un archivo pe. Obtenert el nmero de secciones
; --------------------------------------------------
loc_401264:	movzx	eax, word ptr[edi+6]
		mov	NumberOfSections_, eax
; -----------------------------
; Get the image base
; Obtener la base de la imagen
; -----------------------------
		mov     eax, [edi+4+20+28]
		mov	ImageBase_, eax
; ---------------------------------
; Point to the section header 
; Apuntar al encabezado de seccin
; ---------------------------------
		lea	eax, [edi+4+20+224]
		mov	[ebp-10h], eax

    ; ---------------- GET RESOURCES NUMBER INFO ------------------

; ----------------------------------------------
; Get the offset to raw data of .rsrc section
; Obtener el desplazamiento de la seccin .rsrc
; ----------------------------------------------
		push	2
		push	pFile
		call	GetPointerToSection
		or	eax, eax
		jnz	loc_4012DA
		
		push	30h
		push	offset CaptionStr
		push	offset Msg03		; No resources
		push	0
		call	MessageBoxA
		pop	esi
		jmp 	a00

loc_4012DA:	mov	pResSect, eax
		mov	esi, eax
; --------------------------------------
; get the number of type of resources
; obtener el nmero de tipo de recursos
; --------------------------------------
loc_40130B:	push	offset rt		; address of structure
		push	esi			; -> Resources Section
		call	GetResNumber1
		mov	[ebp-28h], eax
; -----------------------------------------------------------------------
; Get the size of memory to alloc for RESOURCE_TYPE struct. arrays
; Obtener la cantidad de memoria a reservar
; -----------------------------------------------------------------------
		mov	[ebp-16h], eax		; Number of type of resources
                push    eax
		mov	ecx, sizeof RESOURCE_TYPE
		mul	ecx
; ---------------------------------------------------
; Alloc memory for RESOURCE_TYPE structures array.
; Each entry has info about type of res, res number 
; of this type, and  address where find its info.
;
; Localizar memoria para el array de estructuras 
; RESOURCE_TYPE. Cada entrada tiene info sobre el
; tipo de res, el nmero de recursos de
; este tipo y dnde encontrar su info.
; ---------------------------------------------------
		push	eax
		call	AlllocMemory
		mov	pMem1, eax
	; ------------------------------
	; Get the number of resources
	; Obtener el nmero de recursos
	; ------------------------------
		push	offset rtn
		push	pResSect
		call	GetResNumber2
		mov	word ptr [ebp-18h], ax
; ----------------------------------------------------------------------
; Get the size of memory to alloc for RESOURCE_TYPE_ENTRY struct. array
; Obtener la cantidad de memoria a reservar
; ----------------------------------------------------------------------
		mov	ecx, sizeof RESOURCE_TYPE_ENTRY
		mul	ecx
; -------------------------------------------------------------------
; Alloc memory for RESOURCE_TYPE_ENTRY structures array
; Localizar memoria para el array de estructuras RESOURCE_TYPE_ENTRY
; -------------------------------------------------------------------
		push	eax
		call	AlllocMemory
		mov	pMem2, eax
; ----------------------------------------------------
; To fill the RESOURCE_TYPE structures array.
; Each entry has info about the ID, offset, VA and
; size of the resource.
;
; Llenar el array de estructuras RESOURCE_TYPE.
; Cada entrada tiene info sobre el ID, desp., VA y
; tamao del recurso.
; ----------------------------------------------------
		mov	ecx, [ebp-16h]
		push	eax
		push	pMem1
		push	ecx
		push	pResSect
		call	GetResTypeDirectory
; ------------------------------------------------
; To fill the RESOURCE_TYPE_ENTRY entries array
; Llenar el array de entradas RESOURCE_TYPE_ENTRY
; ------------------------------------------------
		push	pFile
		push	ImageBase_
		push	pMem2
		push	pResSect
		call	GetResTypeEntryDir

; ------------------ Now initialize the treeview control ----------------

; ----------------------------------
; Get treeview handle
; Obtener el manejador del treeview
; ----------------------------------
		push	64h
		push	dword ptr [ebp+8]
		call	GetDlgItem
		mov	[ebp-0A8h], eax
; -----------------------------------------------------
; Create a image list for treeview
; Crear una lista de imgenes para el control treeview
;  ----------------------------------------------------
		push	eax
		call	SetTreeViewImageList
		or	eax, eax
		jnz	loc_401428
		jmp	a00
; -----------------------------------------
; Display root in treeview control
; Desplegar la raiz en el control treeview
; -----------------------------------------
loc_401428:	movzx	eax, word ptr [ebp-16h] ; number of resource types
		push	pMem2
		push	pMem1
		push	eax
		push	dword ptr [ebp-0A8h]
		call	DisplayItInTreeView
		or	eax, eax
		jnz	loc_40145D
		jmp     a00
; --------------------------------------
; Display the info in listview control
; Desplegar info en el control listview
; --------------------------------------
	; ----------------------------------
	; Get listview handle
	; Obtener el manejador del listview
	; ----------------------------------
loc_40145D:	push	3F2h
		push	dword ptr [ebp+8]
		call	GetDlgItem
		mov	[ebp-48h], eax
	; ----------------------------------
	; Get the size of columns
	; Obtener el tamao de las columnas
	; ----------------------------------
		lea	eax, [ebp-44h]
		push	eax
		push	dword ptr [ebp-48h]
		call	GetWindowRect
		mov	eax, [ebp-3Ch]
		sub	eax, [ebp-44h]
		xor	edx, edx
		mov	ecx, 4
		div	ecx
		dec	eax
		dec	eax

		mov	[ebp-60h], eax
		mov	dword ptr [ebp-68h], 0Fh
		lea	edi, buffer
		mov	[ebp-5Ch], edi
		mov	dword ptr [ebp-64h], 0
		mov	dword ptr [ebp-54h], 0
	; ---------------------------------------------
	; Insert the columns in listview control
	; Insertar las columnas en el control listview
	; ---------------------------------------------
loc_4014CE:	mov	esi, 1Ah
		mov	ecx, 4
loc_4014D8:	push	ecx
		push	15h
		push	edi
		call	RtlZeroMemory
	; --------------------------------
	; Get the string of column
	; Obtener la cadena de la columna
	; --------------------------------
		push	14h
		push	edi
		push	esi
		push	hMod
		call	LoadStringA
	; --------------------
	; Insert the column
	; Insertar la columna
	; --------------------
		lea	eax, [ebp-68h]
		push	eax
		push	0
		push	101Bh
		push	3F2h
		push	dword ptr [ebp+8]
		call	SendDlgItemMessageA

		inc	dword ptr [ebp-54h]
		dec	esi
		pop	ecx
		cmp	ecx, 4
		jnz	loc_401519
		mov	dword ptr [ebp-64h], 1

loc_401519:	loop	loc_4014D8
		jmp	loc_4018DF			; return


; ------------------------------ WM_ NOTIFY ------------------------------


loc_401520:	cmp	eax, WM_NOTIFY
		jnz	loc_401681
; ==================================
; Process the WM_NOTIFY message
; Procesar el mensaje WM_NOTIFY
; ==================================
		mov	eax, [ebp+14h]
		mov	ecx, [eax+8]	; NMHDR.code
		cmp	cx, 0FFFBh
		jnz	loc_4015FE
; ----------------------
; What has been clicked
; Qu ha sido pulsado
; ----------------------
		mov	ecx, [eax]	; NMHDR.hwndFrom
		push	ecx
		call	SetFocus

		push	64h
		push	dword ptr [ebp+8]
		call	GetDlgItem

		lea	ecx, [ebp-44h]
		push	ecx
		push	eax
		call	GetWindowRect
		lea	eax, [ebp-34h]
		push	eax
		call	GetCursorPos
		mov	ecx, [ebp-34h]
		mov	eax, [ebp-3Ch]
		cmp	eax, ecx
		jnl	loc_4015F9

		push	3F2h
		push	dword ptr [ebp+8]
		call	GetDlgItem
		push	eax
		lea	eax, [ebp-0A4h]
		push	eax
		call	GetCursorPos

		pop	ecx
		push	ecx

		lea	eax, [ebp-0A4h]
		push	eax
		push	ecx
		call	ScreenToClient

		pop	ecx
		lea	eax, [ebp-0A4h]
		push	eax
		push	0
		push	LVM_HITTEST
		push	ecx
		call	SendMessageA
		cmp	eax, -1
		jz	loc_4015F9
; -------------------
; Display the menu
; Desplegar el men
; -------------------
		call	CreatePopupMenu
		or	eax, eax
		jz	loc_4018DF

		mov	[ebp-0Ch], eax
		push	offset StrMenu1
		push	0C8h
		push	0
		push	eax
		call	AppendMenuA
	; ---------------------------
	; Get the resource type
	; Obtener el tipo de recurso
	; ---------------------------
		push	pMem1
		push	64h
		push	dword ptr [ebp+8]
		call	GetResType
	; -----------------------------
	; Dump a icon file?
	; Volcar un archivo de icono?
	; -----------------------------
		cmp	eax, RT_GROUP_ICON
		jne	@300

		push	offset StrMenu2
		push	0C9h
		push	0
		push	dword ptr [ebp-0Ch]
		call	AppendMenuA

@300:		lea	eax, [ebp-34h]
		push	eax
		call	GetCursorPos

		push	0
		push	dword ptr [ebp+8]
		push	0
		push	dword ptr [ebp-30h]
		push	dword ptr [ebp-34h]
		push	2
		push	dword ptr [ebp-0Ch]
		call	TrackPopupMenu

		push	dword ptr [ebp-0Ch]
		call	DestroyMenu

loc_4015F9:	jmp	loc_4018DF

loc_4015FE:	cmp	ecx, 0FFFFFE6Eh
		jnz	loc_401652
		push	eax

		push	64h
		push	dword ptr [ebp+8]
		call	GetDlgItem

		lea	ecx, [ebp-44h]
		push	ecx
		push	eax
		call	GetWindowRect

		lea	eax, [ebp-34h]
		push	eax
		call	GetCursorPos
		pop	eax

		mov	ecx, [ebp-34h]
		cmp	[ebp-3Ch], ecx
		jbe	loc_4018DF

		mov	ecx, [eax+14h]
		or	ecx, ecx
		jnz	loc_401641

		cmp	flag_0, 0
		jz	loc_401644

loc_401641:	mov	ecx, [eax+3Ch]

loc_401644:	push	ecx
		push	dword ptr [ebp+8]
		call	sub_401A83
		jmp	loc_4018DF

loc_401652:	cmp	ecx, 0FFFFFFFEh
		jnz	loc_4018DF

		push	flag_0
		push	dword ptr [ebp+8]
		call	sub_401A83

		cmp	flag_0, 0
		jnz	loc_40167C

		mov	flag_0, 1

loc_40167C:	jmp	loc_4018DF


; --------------------------- WM_COMMAND -----------------------------------


loc_401681:	cmp	eax, WM_COMMAND
		jnz	ret_fals
; ==================================
; Process the WM_COMMAND message
; Procesar el mensaje WM_COMMAND
; ==================================
		mov	eax, [ebp+10h]
		cmp	eax, 2
		jnz	loc_4016AE
; -------------------
; Exit
; Salir del programa
; -------------------
		push    0
		push	dword ptr [ebp+8]
		call	EndDialog
		jmp	ret_fals

loc_4016AE:	cmp	eax, 0C8h
		jnz	is_dump_ico
; ------------------
; Dump a resource
; Volcar un recurso
; ------------------
		mov	ebx, [ebp+8]
	; -----------------------------------
	; Get the list view handle
	; Obtener el manejador del list view
	; -----------------------------------
		push	3F2h
		push	ebx
		call	GetDlgItem
	; ---------------------------------------------------------------
	; Get the offset and the size of the selected resource
	; Obtener el desplazamiento y el tamao del recurso seleccionado
	; ---------------------------------------------------------------
		lea	ecx, unk_404498
		push	ecx
		push	eax
		call	GetSizeAndOffsetOfRes

		lea	edi, FileName
		call	ZeroBuffer

		push	offset ofn
		call	GetSaveFileNameA

		or	eax, eax
		jnz	loc_4017F2
		jmp	loc_4018DF

loc_4017F2:	push	0
		push	0
		push	2
		push	0
		push	3
		push	0C0000000h
		push	offset FileName
		call	CreateFileA
		cmp	eax, -1
		jnz	loc_401829

		push	30h
		push	offset CaptionStr
		push	offset Msg00
		push	0
		call	MessageBoxA
		jmp	ret_fals

loc_401829:	mov	[ebp-4], eax
		lea	esi, unk_404498
		mov	ecx, [esi+4]	; size of resource data
		mov	[ebp-2Ch], ecx
		mov	edi, ecx

		cmp	word ptr [ebp-22h], 2
		jnz	loc_401846
		add	edi, 0Eh

loc_401846:	push	0
		push	edi
		push	0
		push	4
		push	0
		push	dword ptr [ebp-4]
		call	CreateFileMappingA

		mov	[ebp-8], eax
		push	dword ptr [ebp-4]
		call	CloseHandle

		push	edi
		push	0
		push	0
		push	6
		push	dword ptr [ebp-8]
		call	MapViewOfFile

		mov	edi, eax
		push	edi
		push	dword ptr [ebp-8]
		call	CloseHandle

		cmp	word ptr [ebp-22h], 2
		jnz	loc_401898

		mov	ecx, [esi]
		add	ecx, pFile
		push	dword ptr [ebp-2Ch]
		push	ecx
		push	edi
		call	sub_4020F6
		add	edi, 0Eh

loc_401898:	cld	
		mov	ecx, [esi+4]
		mov	esi, [esi]
		add	esi, pFile
		rep movsb

		call	UnmapViewOfFile
		jmp	loc_4018DF

is_dump_ico:	cmp	eax, 0C9h
		jnz	loc_4018DF
		mov	ebx, [ebp+8]
	; -----------------------------------
	; Get the list view handle
	; Obtener el manejador del list view
	; -----------------------------------
		push	3F2h
		push	ebx
		call	GetDlgItem
	; ---------------------------------------------------------------
	; Get the offset and the size of the selected resource
	; Obtener el desplazamiento y el tamao del recurso seleccionado
	; ---------------------------------------------------------------
		lea	ecx, unk_404498
		push	ecx
		push	eax
		call	GetSizeAndOffsetOfRes
	; ----------------------------------------------
	; Get a pointer to GRPICONDIR
	; Obtener un puntero a la estructura GRPICONDIR
	; ----------------------------------------------
		push	eax
		push	pFile
		call	GetIcoFile

		push	0
		push	offset CaptionStr
		push	offset Msg03
		push	0
		call	MessageBoxA

loc_4018DF:	xor	eax, eax
		inc	al
		pop	ebx
		pop	esi
		pop	edi
		leave	
		ret	10h

ret_fals:	xor	eax, eax
		pop	ebx
		pop	esi
		pop	edi
		leave	
		ret	10h

; ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

; ####################################
; Create a image list
; Crear una lista de imgenes
; ####################################

SetTreeViewImageList	proc near
		push	ebp
		mov	ebp, esp
		add	esp, 0FFFFFFFCh

		pusha	

		push	0
		push	2
		push	10h
		push	10h
		push	10h
		call	ImageList_Create
		or	eax, eax
		jnz	loc_401908

		popa	
		xor	eax, eax
		leave	
		retn	4

loc_401908:	mov	[ebp-4], eax
		push	3E9h
		push	hMod
		call	LoadBitmapA
		mov	edi, eax

		push	0
		push	eax
		push	dword ptr [ebp-4]
		call	ImageList_Add

		push	eax
		push	edi
		call	DeleteObject

		pop	eax
		cmp	eax, 0FFFFFFFFh
		jnz	loc_40193C

		popa	
		xor	eax, eax
		leave	
		retn	4

loc_40193C:	push	dword ptr [ebp-4]
		push	0
		push	1109h
		push	dword ptr [ebp+8]
		call	SendMessageA
		popa	
		leave	
		retn	4
SetTreeViewImageList	endp

; ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

DisplayItInTreeView	proc near
		push	ebp
		mov	ebp, esp
		add	esp, 0FFFFFF94h
		pusha	
		mov	esi, [ebp+10h]
		mov	edi, [ebp+14h]
		xor	ecx, ecx
		mov	[ebp-68h], ecx

loc_401965:	push	ecx
		mov	dword ptr [ebp-2Ch], 27h
		mov	dword ptr [ebp-30h], 0FFFF0000h
		mov	dword ptr [ebp-34h], 0
		mov	dword ptr [ebp-10h], 1
		mov	dword ptr [ebp-14h], 0
		push	dword ptr [ebp-68h]
		pop	dword ptr [ebp-8]
		push	40h
		push	offset buffer
		call	RtlZeroMemory
		movzx	eax, word ptr [esi]
		push	40h
		push	offset buffer
		push	eax
		push	hMod
		call	LoadStringA
		mov	dword ptr [ebp-1Ch], offset buffer
		lea	eax, [ebp-34h]
		push	eax
		push	0
		push	1100h
		push	dword ptr [ebp+8]
		call	SendMessageA
		mov	[ebp-34h], eax

		movzx	ebx, word ptr [esi+2]
		test	ebx, ebx
		jz	loc_401A68
		mov	dword ptr [ebp-6Ch], 0

loc_4019E1:	push	40h
		push	offset buffer
		call	RtlZeroMemory

		push	dword ptr [ebp-6Ch]
		pop	dword ptr [ebp-8]
		mov	eax, [edi]
		mov	ecx, eax
		shr	ecx, 1Fh
		test	cl, cl
		jz	loc_401A16
		and	eax, 7FFFFFFFh
		add	eax, pResSect
		push	offset buffer
		push	eax
		call	AnsiToUnicode
		jmp	loc_401A29

loc_401A16:	push	eax
		push	offset template1
		push	offset buffer
		call	wsprintfA
		add	esp, 0Ch

loc_401A29:	push	offset buffer
		call	GetStrLen
		mov	[ebp-18h], eax
		mov	dword ptr [ebp-1Ch], offset buffer
		or	dword ptr [ebp-2Ch], 4
		mov	dword ptr [ebp-30h], 0FFFF0002h

		lea	eax, [ebp-34h]
		push	eax
		push	0
		push	1100h
		push	dword ptr [ebp+8]
		call	SendMessageA

		add	edi, 10h
		inc	dword ptr [ebp-6Ch]
		dec	ebx
		jnz	loc_4019E1

loc_401A68:	add	esi, 8
		inc	dword ptr [ebp-68h]
		pop	ecx
		inc	ecx
		cmp	ecx, [ebp+0Ch]
		jl	loc_401965
		popa	
		mov	eax, 1
		leave	
		retn	10h
DisplayItInTreeView	endp

; ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

sub_401A83	proc near
		push	ebp
		mov	ebp, esp
		add	esp, 0FFFFFF7Ch
		push	esi
		push	3F2h
		push	dword ptr [ebp+8]
		call	GetDlgItem
		mov	[ebp-78h], eax

		push	64h
		push	dword ptr [ebp+8]
		call	GetDlgItem
		mov	[ebp-84h], eax

		lea	eax, [ebp-64h]
		push	eax
		call	GetCursorPos

		lea	eax, [ebp-64h]
		push	eax
		push	dword ptr [ebp-84h]
		call	ScreenToClient

		lea	eax, [ebp-64h]
		push	eax
		push	0
		push	1111h
		push	dword ptr [ebp-84h]
		call	SendMessageA
		cmp	eax, [ebp+0Ch]
		jz	loc_401B0A

		mov	eax, [ebp+0Ch]
		cmp	dword ptr [ebp+0Ch], 0
		jnz	loc_401B03

		push	0
		push	0
		push	110Ah
		push	dword ptr [ebp-84h]
		call	SendMessageA
		or	eax, eax
		jz	loc_401B03
		jmp	loc_401B22

loc_401B03:	jmp	loc_401E80

loc_401B0A:	or	eax, eax
		jnz	loc_401B22
		push	0
		push	0
		push	110Ah
		push	dword ptr [ebp-84h]
		call	SendMessageA

loc_401B22:	mov	[ebp-24h], eax
		mov	[ebp-7Ch], eax
		push	0
		push	0
		push	1009h
		push	dword ptr [ebp-78h]
		call	SendMessageA
		mov	dword ptr [ebp-28h], 55h
		mov	dword ptr [ebp-18h], offset buffer
		mov	dword ptr [ebp-14h], 40h
		push	40h
		push	offset buffer
		call	RtlZeroMemory
		lea	eax, [ebp-28h]
		push	eax
		push	0
		push	110Ch
		push	dword ptr [ebp-84h]
		call	SendMessageA
		mov	eax, [ebp-8]
		mov	[ebp-6Ch], eax
		or	eax, eax
		jnz	loc_401BBC
		push	dword ptr [ebp-4]
		pop	dword ptr [ebp-80h]
		push	dword ptr [ebp-24h]
		push	3
		push	110Ah
		push	64h
		push	dword ptr [ebp+8]
		call	SendDlgItemMessageA
		mov	[ebp-24h], eax
		push	40h
		push	offset buffer
		call	RtlZeroMemory
		or	dword ptr [ebp-28h], 4
		lea	eax, [ebp-28h]
		push	eax
		push	0
		push	110Ch
		push	64h
		push	dword ptr [ebp+8]
		call	SendDlgItemMessageA

loc_401BBC:	push	dword ptr [ebp-4]
		pop	dword ptr [ebp-70h]
		and	dword ptr [ebp-70h], 0FFFFh
		mov	esi, pMem1
		mov	eax, 8
		mul	dword ptr [ebp-70h]
		add	esi, eax
		push	dword ptr [esi+4]
		pop	dword ptr [ebp-74h]
		cmp	dword ptr [ebp-6Ch], 0
		jnz	loc_401C20
		mov	dword ptr [ebp-4Ch], 0
		mov	dword ptr [ebp-48h], 0
		mov	dword ptr [ebp-50h], 1
		mov	dword ptr [ebp-3Ch], offset buffer
		mov	dword ptr [ebp-6Ch], 1
		push	dword ptr [ebp-7Ch]
		pop	dword ptr [ebp-24h]
		mov	eax, 10h
		mul	dword ptr [ebp-80h]
		mov	esi, [ebp-74h]
		add	esi, eax
		jmp	loc_401D86

loc_401C20:	push	word ptr [esi+2]
		pop	dword ptr [ebp-6Ch]
		and	dword ptr [ebp-6Ch], 0FFFFh
		push	dword ptr [ebp-24h]
		push	4
		push	110Ah
		push	64h
		push	dword ptr [ebp+8]
		call	SendDlgItemMessageA
		mov	[ebp-24h], eax
		push	40h
		push	offset buffer
		call	RtlZeroMemory
		lea	eax, [ebp-28h]
		push	eax
		push	0
		push	110Ch
		push	64h
		push	dword ptr [ebp+8]
		call	SendDlgItemMessageA
		mov	dword ptr [ebp-4Ch], 0
		mov	dword ptr [ebp-48h], 0
		mov	dword ptr [ebp-50h], 1
		mov	dword ptr [ebp-3Ch], offset buffer
		mov	dword ptr [ebp-38h], 40h
		mov	esi, [ebp-74h]
		lea	eax, [ebp-50h]
		push	eax
		push	0
		push	1007h
		push	dword ptr [ebp-78h]
		call	SendMessageA
		inc	dword ptr [ebp-48h]
		push	40h
		push	offset buffer
		call	RtlZeroMemory
		mov	eax, [esi+8]
		push	eax
		push	offset template2
		push	offset buffer
		call	wsprintfA
		add	esp, 0Ch
		lea	eax, [ebp-50h]
		push	eax
		push	0
		push	1006h
		push	3F2h
		push	dword ptr [ebp+8]
		call	SendDlgItemMessageA
		inc	dword ptr [ebp-48h]
		push	40h
		push	offset buffer
		call	RtlZeroMemory
		mov	eax, [esi+4]
		push	eax
		push	offset template2
		push	offset buffer
		call	wsprintfA
		add	esp, 0Ch
		lea	eax, [ebp-50h]
		push	eax
		push	0
		push	1006h
		push	3F2h
		push	dword ptr [ebp+8]
		call	SendDlgItemMessageA
		inc	dword ptr [ebp-48h]
		push	40h
		push	offset buffer
		call	RtlZeroMemory
		mov	eax, [esi+0Ch]
		push	eax
		push	offset template2
		push	offset buffer
		call	wsprintfA
		add	esp, 0Ch
		lea	eax, [ebp-50h]
		push	eax
		push	0
		push	1006h
		push	3F2h
		push	dword ptr [ebp+8]
		call	SendDlgItemMessageA

loc_401D56:	add	esi, 10h
		inc	dword ptr [ebp-4Ch]
		mov	dword ptr [ebp-48h], 0
		push	dword ptr [ebp-24h]
		push	1
		push	110Ah
		push	64h
		push	dword ptr [ebp+8]
		call	SendDlgItemMessageA
		mov	ecx, eax
		inc	eax
		test	ecx, ecx
		jz	loc_401E80
		dec	eax
		mov	[ebp-24h], eax

loc_401D86:	push	40h
		push	offset buffer
		call	RtlZeroMemory
		lea	eax, [ebp-28h]
		push	eax
		push	0
		push	110Ch
		push	64h
		push	dword ptr [ebp+8]
		call	SendDlgItemMessageA
		lea	eax, [ebp-50h]
		push	eax
		push	0
		push	1007h
		push	dword ptr [ebp-78h]
		call	SendMessageA
		inc	dword ptr [ebp-48h]
		push	40h
		push	offset buffer
		call	RtlZeroMemory
		mov	eax, [esi+8]
		push	eax
		push	offset template2
		push	offset buffer
		call	wsprintfA
		add	esp, 0Ch
		lea	eax, [ebp-50h]
		push	eax
		push	0
		push	1006h
		push	3F2h
		push	dword ptr [ebp+8]
		call	SendDlgItemMessageA
		inc	dword ptr [ebp-48h]
		push	40h
		push	offset buffer
		call	RtlZeroMemory
		mov	eax, [esi+4]
		push	eax
		push	offset template2
		push	offset buffer
		call	wsprintfA
		add	esp, 0Ch
		lea	eax, [ebp-50h]
		push	eax
		push	0
		push	1006h
		push	3F2h
		push	dword ptr [ebp+8]
		call	SendDlgItemMessageA
		inc	dword ptr [ebp-48h]
		push	40h
		push	offset buffer
		call	RtlZeroMemory
		mov	eax, [esi+0Ch]
		push	eax
		push	offset template2
		push	offset buffer
		call	wsprintfA
		add	esp, 0Ch
		lea	eax, [ebp-50h]
		push	eax
		push	0
		push	1006h
		push	3F2h
		push	dword ptr [ebp+8]
		call	SendDlgItemMessageA
		cmp	dword ptr [ebp-6Ch], 1
		jnz	loc_401E7B
		jmp	loc_401E80

loc_401E7B:	jmp	loc_401D56

loc_401E80:	pop	esi
		leave	
		retn	8
sub_401A83	endp

; ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

GetPointerToSection	proc near
		push	ebp
		mov	ebp, esp
; ----------------------------------------------------------
; Get the offset to raw data of .rsrc section
; Obtner el desplazamiento de los datos de la seccin .rsrc
; ----------------------------------------------------------
		push	dword ptr [ebp+0Ch]
		push	dword ptr [ebp+8]
		call	GetOffsetOfSection
		or	eax, eax
		jz	loc_401EC7
; -----------------------
; Convert it in pointer
; Convertirlo en puntero
; -----------------------
		add	eax, [ebp+8]
loc_401EC7:	leave	
		ret	8
GetPointerToSection	endp


; ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

GetRVAOfSection	proc near
		push	ebp
		mov	ebp, esp
		add	esp, 0FFFFFFF8h
; ------------------------------------------
; Get a pointer to optional header
; Obtener un puntero al encabezado opcional
; ------------------------------------------
		mov     eax, [ebp+8]
                add     eax, [eax+03Ch]
		add	eax, 4+14h
                mov     [ebp-4], eax
; -------------------------
; Does exist this section
; Existe la seccin
; -------------------------
		mov	ecx, [ebp+0Ch]		; index to find
		cmp	[eax+5Ch], ecx          ; Number of rva
		ja	loc_401F1C

		xor	eax, eax
		jmp	loc_401F26
; ---------------------------------
; Return a pointer to section
; Regresar un puntero a la seccin
; ---------------------------------
loc_401F1C:	mov	ecx, [ebp+0Ch]		; index
		mov	eax, dword ptr [(ecx*8)+(eax+60h)]
loc_401F26:	leave	
		retn	8
GetRVAOfSection	endp

; ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

GetOffsetOfSection	proc near
		push	ebp
		mov	ebp, esp
		add	esp, 0FFFFFFF8h

		pusha	

		mov	dword ptr [ebp-8], 0
		cmp	dword ptr [ebp+0Ch], 10h
		jge	loc_401F79
; -----------------------------------------------
; get a pointer to the section header
; obtener un puntero al encabezado de la seccin
; -----------------------------------------------
		mov	eax, [ebp+8]
		add	eax, [eax+3Ch]
		mov	esi, eax
		add	esi, 4+14h+0E0h
; -------------------------------
; Get the RVA to section
; Obtener la RVA de una seccin
; -------------------------------
		push	dword ptr [ebp+0Ch]
		push	dword ptr [ebp+8]
		call	GetRVAOfSection
		xor	edi, edi
		dec	edi
		jmp	loc_401F66
loc_401F61:	cmp	edi, 10h
		jg	loc_401F79
; ----------------
; Match the rva
; Coincide la rva
; ----------------
loc_401F66:	mov	ecx, [esi+0Ch]
		cmp	eax, ecx
		jz	loc_401F73
; ------------------------------------
; No, get the next section header
; No, obtener el siguiente encabezado
; ------------------------------------
		add	esi, 28h
		inc	edi
		jmp	loc_401F61
; -----------------------------------------------------
; Return the offset to raw data of the .rsrc section 
; Regresar el desplazamiento a los datos de la seccin
; -----------------------------------------------------
loc_401F73:	mov	eax, [esi+14h]
		mov	[ebp-8], eax

loc_401F79:	popa	
		mov	eax, [ebp-8]
		leave	
		retn	8
GetOffsetOfSection	endp


; ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

GetResNumber1	proc near
		push	ebp
		mov	ebp, esp
		add	esp, 0FFFFFFFCh
		pusha
		; -----------------------------------
		; point to IMAGE_RESOURCE_DIRECTORY
		; apuntar a IMAGE_RESOURCE_DIRECTORY
		; -----------------------------------
		mov	esi, [ebp+8]
		; ---------------------------------------
		; Get the NumberOfNamedEntries
		; Obtener el mmero de entradas nombradas
		; ---------------------------------------
		movzx	ecx, word ptr [esi+0Ch]
		mov	edi, [ebp+0Ch]
		mov     [edi], word ptr cx
		; -------------------------------------
		; Get the NumberOfIddEntries
		; Obtener el mmero de entradas con ID
		; -------------------------------------
		movzx	eax, word ptr [esi+0Eh]	; NumberOfIdEntries
		mov     [edi+2], word ptr ax
		; -----------------------------------
		; Get the total number of entries
		; Obtener el mmero total de entradas
		; -----------------------------------
		add	eax, ecx
		mov	[ebp-4], eax
		popa	
		mov	eax, [ebp-4]
		leave	
		retn	8
GetResNumber1	endp

; ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

GetResNumber2 proc uses esi pRs:DWORD, prtn:DWORD, uRt:DWORD
	local i:DWORD
	; ----------------------------------------------
	; Number of types of resources = number of loops
	; Nmero de tipos de recursos = nmero de bucles
	; ----------------------------------------------
		mov	ecx, uRt
		mov	i, 0
	; -----------------------------------------------------------
	; Point to first _IMAGE_RESOURCE_DIRECTORY_ENTRY array
	; Apuntar al primer array de _IMAGE_RESOURCE_DIRECTORY_ENTRY
	; -----------------------------------------------------------
		mov	esi, pRs
		add	esi, 10h
                push    esi	; array de _IMAGE_RESOURCE_DIRECTORY_ENTRY
; ------------------------------
; Get the number of resources
; Obtener el nmero de recursos
; ------------------------------
loc_401353:	push	ecx
	; ---------------------------------------------
	; Point to a type resource directory
	; Apuntar al directorio de un tipo de recursos
	; ---------------------------------------------
		mov	eax, [esi+4]	; OffsetToData of first type
		and	eax, 7FFFFFFFh	; Clean the flag
		add	eax, pRs
	; -------------------------------------------
	; Get the number of resources of this type
	; Obtener el nmero de recursos de este tipo
	; -------------------------------------------
		push	prtn		; address of structure
		push	eax		; -> directory of the first type
		call	GetResNumber1
		and	eax, 0FFFFh
		add	i, eax
		add	esi, sizeof RESOURCE_TYPE_NUMBER 
		pop	ecx
		loop	loc_401353
		mov	eax, i
		ret
GetResNumber2	endp

; :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

GetResTypeDirectory	proc uses esi edi ebx pRs:DWORD, uR:DWORD, pM1:DWORD, pM2:DWORD
		mov	esi, pRs
		add	esi, 10h	; pointer to first IMAGE_RESOURCE_DIRECTORY_ENTRY
		xor	ebx, ebx
		mov	edi, pM1
		mov	eax, pM2
		jmp	loc_4013DB

loc_4013A2:	push	eax
		mov	[edi+4], eax		; pMem2
		movzx	ecx, word ptr [esi]	; type
		mov	[edi], cx
		push	esi	; pointer to first IMAGE_RESOURCE_DIRECTORY_ENTRY
	; -----------------------
	; Point to first type
	; Apuntar al primer tipo
	; -----------------------
		mov	esi, [esi+4]		; offset
		and	esi, 7FFFFFFFh
		add	esi, pResSect           ; pointer
	; --------------------------------------------
	; Get the number of resources of this type
	; Obntener el nmero de recursos de este tipo
	; --------------------------------------------
		movzx	ecx, word ptr [esi+0Eh] ; NumberOfIdEntries
		add	cx, [esi+0Ch] 		; NumberOfNamedEntries
		mov	[edi+2], cx

		add	edi, sizeof RESOURCE_TYPE
		pop	esi	; pointer to first IMAGE_RESOURCE_DIRECTORY_ENTRY
		add	esi, sizeof IMAGE_RESOURCE_DIRECTORY_ENTRY
		mov	eax, 10h
		mul	ecx
		pop	ecx
		add	eax, ecx
		inc	bx

loc_4013DB:	mov	edx, uR
		cmp	bx, dx		; [ebp-16h] number of resource types
		jb	loc_4013A2
		mov	eax, 1
		ret
GetResTypeDirectory endp

; ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

;		[ebp+20]  pFile:     Puntero al archivo proyectado
;		[ebp+16]  ImageBase: Base of the pe file
;		[ebp+12]  pMem:      Memory buffer pointer
;		[ebp+8]	  pRS:       Res section pointer


GetResTypeEntryDir	proc near
		push	ebp
		mov	ebp, esp
		add	esp, 0FFFFFFF0h
		pusha
		mov	esi, [ebp+8]		; Res section pointer
; -----------------------
; Calculate RVA of .rsrc
; Clacular RVA de .rsrc
; -----------------------
		push	2
		push	[ebp+20]
		call	GetRVAOfSection
		mov	ebx, eax
; ----------------------------------------------
; Get number of resources of this type
; Obtener el nmero de directorios de este tipo
; ----------------------------------------------
		movzx	ecx, word ptr [esi+0Eh] ; NumberOfIdEntries
		add	cx, [esi+0Ch]		; NumberOfNamedEntries
		mov	[ebp-2], cx
; ----------------------------------------
; Get a pointer to first entry
; Obtener un puntero a la primera entrada
; ----------------------------------------
		add	esi, 10h
		mov	[ebp-10h], esi		; Res type
; -----------------------------------------
; Get a pointer to ResTypeEntry array
; Obtener un puntero al array ResTypeEntry
; -----------------------------------------
		mov	edi, [ebp+12]		; pMem2
		xor	ecx, ecx
		jmp	loc_402051

loc_401FD4:	push	ecx
	; ----------------------------------------------------
	; Get a pointer to a resource of a type info
	; Obtener un puntero a la info del recurso de un tipo
	; ----------------------------------------------------
		mov	esi, [esi+4]		; offset from begin of sect.
		and	esi, 7FFFFFFFh		; clean flag
		add	esi, [ebp+8]		; point to res info
	; -------------------------------------------
	; Get the number of resources of this type
	; Obtener el nmero de recursos de este tipo
	; -------------------------------------------
		movzx	ecx, word ptr [esi+0Eh]
		add	cx, [esi+0Ch]
		mov	[ebp-6], cx
	; -----------------------------------
	; Point to resource entries
	; Apuntar a las entradas del recurso
	; -----------------------------------
		add	esi, 10h
		mov	[ebp-0Ch], esi
		xor	ecx, ecx
		jmp	loc_402041

loc_401FF7:	push	ecx
		mov	ecx, 2
	; ---------------------------------------
	; Get number of named entries
	; obtener nmero de entradas de nombres
	; ---------------------------------------
		mov	eax, [esi]
		mov	[edi], eax
		jmp	loc_402006

loc_402003:
	; -----------------------------------------
	; Point to IMAGE_RESOURCE_DIRECTORY_ENTRY
	; Apuntar a IMAGE_RESOURCE_DIRECTORY_ENTRY
	; -----------------------------------------
		add	esi, 10h
loc_402006:
	; ----------------------------------------------------
	; Point to a resource IMAGE_RESOURCE_DIRECTORY_ENTRY
	; Apuntar a la IMAGE_RESOURCE_DIRECTORY_ENTRY de un recurso
	; -----------------------------------------------------
		mov	eax, [esi+4]
		and	eax, 7FFFFFFFh
		add	eax, [ebp+8]
		mov	esi, eax
		loop	loc_402003
	; -----------------------------------------
	; Get the virtual address of the resource
	; Obtener la direccin virtual del recurso
	; -----------------------------------------
		mov	eax, [esi]	; RVA of the resource
                push    eax
		add	eax, [ebp+10h]	; + the image base
		mov	[edi+8], eax	; VA of the resource
	; ---------------------------------------
	; Get the item offset
	; Obtener el desplazamiento del elemento
	; ---------------------------------------
		pop	eax		; RVA of the resource
		sub	eax, ebx	; - RVA of res section
					; = offset
		mov	ecx, [ebp+8]    ; Pointer to res sect
                sub     ecx, [ebp+20]	; Maped File base
					; = offset of res sect
		add     eax, ecx
 		mov	[edi+4], eax	; res offset
	; ------------------------------
	; Get the res size
	; Obtener el tamao del recurso
	; ------------------------------
		mov	eax, [esi+4]
		mov	[edi+0Ch], eax
	; --------------------------------------------
	; next resource of this type entry
	; siguiente entrada de este tipo de recurso
	; --------------------------------------------
		add	dword ptr [ebp-0Ch], 8
		mov	esi, [ebp-0Ch]
	; ---------------------------------------------
	; next entry in the array
	; siguiente entrada en el array
	; ---------------------------------------------
		add	edi, 10h
		pop	ecx
		inc	ecx

loc_402041:	cmp	cx, [ebp-6]
		jb	loc_401FF7
	; -------------------------
	; Next type
	; Siguiente tipo
	; -------------------------
		add	dword ptr [ebp-10h], 8
		mov	esi, [ebp-10h]
		pop	ecx
		inc	cx
	; ---------------------------------
	; We have revised all types?
	; Hemos revisado todos los tipos?
	; ---------------------------------
loc_402051:	cmp	cx, [ebp-2]
		jb	loc_401FD4
		popa	
		mov	eax, 1
		leave	
		retn	10h
GetResTypeEntryDir	endp

; :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

GetResType	proc	uses ebx edi esi hW:DWORD, uID:DWORD, pM1:DWORD
local	ptvi:TV_ITEM
		mov	ebx, hW
		mov	edi, SendDlgItemMessageA
	; ------------------------------------
	; What item has been selected?
	; Qu elemento ha sido seleccionado?
	; ------------------------------------
		push	0
		push	9		; flag
		push	TVM_GETNEXTITEM
		push	uID
		push	ebx
		call	edi

		push	eax		; hItem
		push	3		; flag
		push	TVM_GETNEXTITEM
		push	uID
		push	ebx
		call	edi
		or	eax, eax
		jnz	loc_401705

		push	0
		push	9		; flag
		push	TVM_GETNEXTITEM
		push	uID
		push	ebx
		call	edi

loc_401705:	lea	esi, ptvi
		mov	dword ptr [esi], 4
		mov	ptvi.hItem, eax

		lea	eax, ptvi 
		push	eax
		push	0
		push	TVM_GETITEM
		push	64h
		push	ebx
		call	edi
	; ---------------------------
	; Get the resource type
	; Obtener el tipo de recurso
	; ---------------------------
		mov	eax, ptvi.lParam
		mov	ecx, 8
		mul	ecx
		mov	esi, pM1
		add	esi, eax
		movzx	eax, word ptr [esi]
		ret
GetResType	endp

; ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

AlllocMemory	proc near
		mov	eax, [esp+4]
		push	ecx
		push	4
		push	1000h
		push	eax
		push	0
		call	VirtualAlloc
		pop	ecx
		retn	4
AlllocMemory	endp

; ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

Str2dword	proc near
		push	ebp
		mov	ebp, esp
		push	esi
		push	edi
		mov	esi, [ebp+8]
		mov	edi, [ebp+0Ch]
		push	esi
		call	GetStrLen
		mov	ecx, eax
		dec	eax
		add	esi, eax
		std	

loc_402096:	mov	edx, 2

loc_40209B:	lodsb
		cmp	al, 39h
		jg	loc_4020A4
		sub	al, 30h
		jmp	loc_4020A6

loc_4020A4:	sub	al, 37h

loc_4020A6:	cmp	dl, 2
		jl	loc_4020B6
		mov	[edi], al
		cmp	cl, 1
		jle	loc_4020BE
		dec	dl
		loop	loc_40209B

loc_4020B6:	shl	al, 4
		xor	[edi], al
		inc	edi
		loop	loc_402096

loc_4020BE:	cld	
		xor	eax, eax
		inc	al
		pop	edi
		pop	esi
		leave	
		retn	8
Str2dword	endp

; ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

AnsiToUnicode	proc near
		push	ebp
		mov	ebp, esp
		push	esi
		push	edi
		push	ebx
		mov	esi, [ebp+8]
		mov	edi, [ebp+0Ch]
		movzx	ecx, word ptr [esi]
		push	ecx
		inc	ecx
		push	ecx
		push	edi
		call	RtlZeroMemory
		pop	ecx
		add	esi, 2
		cld
loc_4020E6:
		lodsb
		stosb
		inc	esi
		loop	loc_4020E6
		xor	eax, eax
		inc	al
		pop	ebx
		pop	edi
		pop	esi
		leave	
		retn	8
AnsiToUnicode	endp


; ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

sub_4020F6	proc near
		push	ebp
		mov	ebp, esp
		add	esp, 0FFFFFFF0h
		push	esi
		push	edi
		mov	edi, [ebp+8]
		mov	esi, [ebp+0Ch]
		mov	ecx, [esi+20h]
		or	ecx, ecx
		jnz	loc_402168
		movzx	ecx, word ptr [esi+0Eh]
		cmp	cx, 1
		jnz	loc_40211C
		mov	ecx, 2
		jmp	loc_402168

loc_40211C:	cmp	cx, 4
		jnz	loc_402129
		mov	ecx, 10h
		jmp	loc_402168

loc_402129:	cmp	cx, 8
		jnz	loc_402136
		mov	ecx, 100h
		jmp	loc_402168

loc_402136:	cmp	cx, 10h
		jnz	loc_402146
		mov	ecx, 2
		shl	ecx, 10h
		jmp	loc_402168

loc_402146:	cmp	cx, 18h
		jnz	loc_402156
		mov	ecx, 2
		shl	ecx, 18h
		jmp	loc_402168

loc_402156:	cmp	cx, 20h
		jnz	loc_402166
		mov	ecx, 2
		shl	ecx, 20h
		jmp	loc_402168

loc_402166:	xor	ecx, ecx

loc_402168:	mov	eax, 4
		mul	ecx
		lea	esi, [ebp-0Eh]
		mov	word ptr [esi],	4D42h
		mov	word ptr [esi+6], 0
		mov	word ptr [esi+8], 0
		add	eax, 0Eh
		add	eax, 28h
		mov	[esi+0Ah], eax
		mov	eax, [ebp+10h]
		add	eax, 0Eh
		mov	[esi+2], eax
		push	0Eh
		push	edi
		call	RtlZeroMemory
		mov	ecx, 0Eh
		rep movsb
		xor	eax, eax
		inc	al
		pop	edi
		pop	esi
		leave	
		retn	0Ch
sub_4020F6	endp

; ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

GetStrLen proc pStr:DWORD
        push   edi
        mov    edi, pStr
        xor    ecx, ecx
        mov    eax, ecx
	dec    ecx
        repne  scasb
        neg    ecx
	dec    cl
        dec    cl
        mov    eax, ecx
	pop    edi
        ret
GetStrLen endp

; =========================================================================
; ZeroBuffer procedure: clean a buffer of 256 bytes size
;                       limpia un buffer de 256 bytes de tamao
; edi=pointer to buffer
;     puntero al buffer
; =========================================================================
ZeroBuffer:   push edi
	      xor eax, eax
              mov ecx, 40h
              rep stosd
              pop edi
              ret

; ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

GetIcoFile	proc uses esi edi ebx pF:DWORD, pgid:DWORD
local		uImgs:DWORD, h:DWORD, i:DWORD, j:DWORD, g:DWORD, p1:DWORD
local		bf[256]:byte

	mov	esi, pgid
	add	esi, pF
	assume  esi: ptr GRPICONDIR
; --------------------------------------
; Alloc a buffer to entries
; Localizar un buffer para las entradas
; --------------------------------------
	xor	ecx, ecx
	mov	cx, [esi].idCount
	mov	uImgs, ecx
	xor	edx, edx
	.if	cx > 1
		mov	eax, sizeof ICONDIRENTRY
		mul	ecx
	.else
		mov	eax, sizeof ICONDIR
	.endif 
	push	PAGE_READWRITE	
	push	MEM_COMMIT
        push	eax
	push	0
	call    VirtualAlloc
	mov	edi, eax
; -------------------------------
; Alloc space for the IDs
; Localizar espacio para los IDs
; -------------------------------
	mov	ecx, uImgs
	.if	cx > 1
		xor	edx, edx
	        mov	eax, 2
		mul     ecx
		push	PAGE_READWRITE	
		push	MEM_COMMIT
	        push	eax
		push	0
		call    VirtualAlloc
	.else
		lea	eax, g
	.endif	
        mov     j, eax
; ----------------------------------
; Fill the ICONDIRENTRYs buffer 
; Llenar el buffer de ICONDIRENTRYs
; ----------------------------------
	xor	ebx, ebx
	; -------------------------------------------
	; Get the size of the ICON header
	; Obtener el tamao del encabezado del icono
	;  ------------------------------------------
	xor	eax, eax
	mov	ecx, uImgs
	.if	cx > 1
		mov	eax, sizeof ICONDIRENTRY
		mul	ecx
		sub	eax, sizeof ICONDIRENTRY
	.endif
	add	eax, sizeof ICONDIR
	mov	h, eax
	; -----------------------------------
	; Get a pointer to IDs array
	; Obtener un puntero al array de IDs
	; -----------------------------------
	mov	edx, j
	xor	eax, eax
	push	edi
	.while	ebx < uImgs
		.if	bx==0
			mov	ecx, sizeof GRPICONDIR
			sub	ecx, sizeof WORD
			rep movsb
			; ---------------
			; Get the ID
			; Obtener el ID
			; ---------------
			xor	eax, eax
			lodsw
			mov	word ptr [edx], ax
			add	edx, 2
			; --------------------
			; Pointer to data
			; Puntero a los datos
			; --------------------
			mov	eax, h
			stosd
			; ----------------------
			; Bytes in the resource
			; Bytes en el recurso
			; ----------------------
			mov	ecx, dword ptr [edi-8]
			add	h, ecx
		.else
			mov	ecx, sizeof GRPICONDIRENTRY
			sub	ecx, sizeof WORD
			rep movsb
			; ---------------
			; Get the ID
			; Obtener el ID
			; ---------------
			xor	eax, eax
			lodsw
			mov	word ptr [edx], ax
			; --------------------
			; Pointer to data
			; Puntero a los datos
			; --------------------
			mov	eax, h
			stosd
			; ----------------------
			; Bytes in the resource
			; Bytes en el recurso
			; ----------------------
			mov	ecx, dword ptr [edi-8]
			add	h, ecx
			; -------------
			; Next ID
			; Siguiente ID
			; -------------
                	add     edx, 2
		.endif
		; -----------------------
		; Next ICONDIRENTRY
		; Siguiente ICONDIRENTRY
		; -----------------------
		inc	ebx
	.endw
; ---------------------------------
; Select a file name
; Seleccionar un nombre de archivo
; ---------------------------------
	pop	p1
	lea	eax, bf
	mov	byte ptr [eax], 0
	push	ofn.lpstrFile
	mov	ofn.lpstrFile, eax
        mov  	ofn.lpstrFilter, offset filter2
	mov  	ofn.lpstrDefExt, offset IcoExt
	push	offset ofn
	call 	GetSaveFileNameA
	mov  	ofn.lpstrDefExt, 0
	pop	ofn.lpstrFile
	test	eax, eax
	je	@free
; -----------------
; Create a file
; Crearr un archivo
; -----------------
	invoke CreateFile, addr bf, GENERIC_WRITE or GENERIC_READ, \
		FILE_SHARE_WRITE, 0, CREATE_ALWAYS, \
		FILE_ATTRIBUTE_NORMAL, 0
	push	eax
	invoke  CreateFileMapping, eax, 0, PAGE_READWRITE, 0, h, 0		
	push	eax
	invoke  MapViewOfFile, eax, FILE_MAP_WRITE, 0, 0, h
	mov	i, eax
	call	CloseHandle
	call	CloseHandle
; -----------------------
; Write the header
; Escribir el encabezado
; -----------------------
	mov	ecx, uImgs
	mov     eax, sizeof ICONDIR
	.if	cx > 1
		push	eax
		dec	cx
		xor	edx, edx
		mov	eax, sizeof ICONDIRENTRY
		mul	ecx
		pop	edx
		add	eax, edx
	.endif 
	mov	esi, p1
	mov	ecx, eax
	mov	edi, i
	rep movsb
	mov	edx, j
; ----------------------
; Write the images
; Escribir las imgenes
; ----------------------
	.while	ebx > 0
                push	edx
		; -----------------------
		; Point to the images
		; Apuntar a las imgenes
		; -----------------------
                xor	eax, eax
		mov	ax, [edx]
		mov	esi, pF
		inc	esi
	        invoke  FindResource, esi, eax, RT_ICON
		or	eax, eax
		je	@free
		push	eax
		invoke  SizeofResource, esi, eax
		mov	h, eax
		push	esi
	        call    LoadResource
		or	eax, eax
		je	@free
	        invoke  LockResource, eax
		or	eax, eax
		je	@free
		; ----------------------
		; Write the images
		; Escribir las imgenes
		; ----------------------
		mov	esi, eax
		mov	ecx, h
		rep movsb
		pop	edx
		add	edx, 2
		dec	ebx
	.endw
; ---------------
; Free memory
; Libera memoria
; ---------------
@free:	mov	eax, MEM_RELEASE
	push	eax
	push	eax
	push	0
	push	p1
	call	VirtualFree
	push	0
	push	j
	call	VirtualFree
	push	i
	call	UnmapViewOfFile
	ret
GetIcoFile	endp

; :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

GetSizeAndOffsetOfRes	proc uses esi edi hLP:DWORD, p00:DWORD
local	lvi:LV_ITEM, bf[256]:byte
	; -------------------------------------------
	; Get the index of selected resource
	; Obtener el ndice del recurso seleccionado
	; -------------------------------------------
		mov	esi, hLP
		push	LVNI_SELECTED
		push	-1
		push	LVM_GETNEXTITEM
		push	esi
		call	SendMessageA
		mov	[ebp-8Ch], eax
	; ---------------------------------------------------------------
	; Get the offset and the size of the selected resource
	; Obtener el desplazamiento y el tamao del recurso seleccionado
	; ---------------------------------------------------------------
		lea	ecx, lvi
		mov	dword ptr [ecx], 1
		mov	lvi.iItem, eax
		mov	lvi.iSubItem, 2
		lea	eax, bf
		mov	lvi.pszText, eax
		mov	lvi.cchTextMax, 9
		mov	ecx, 2
		mov	edi, p00 ; first get the offset of res data
loc_40178B:	push	ecx
		push	0Ah
		lea	eax, bf
		push	eax
		call	RtlZeroMemory

		lea	eax, lvi
		push	eax
		push	0
		push	LVM_GETITEM
		push	esi
		call	SendMessageA

		push	edi
		lea	eax, bf
		push	eax
		call	Str2dword

		add	edi, 4		; get the size of resource data
		inc	lvi.iSubItem
		pop	ecx
		loop	loc_40178B
		mov	eax, [edi-8]
		ret
GetSizeAndOffsetOfRes	endp

; :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

		end start

; -----------------------------------------------------------------------

		push	ebp
		mov	ebp, esp
		add	esp, 0FFFFFFF0h
		push	esi
		push	edi
		mov	edi, [ebp+8]
		lea	esi, [ebp-0Eh]
		mov	word ptr [esi],	4D42h
		mov	word ptr [esi+6], 0
		mov	word ptr [esi+8], 0
		mov	dword ptr [esi+0Ah], 0Eh
		mov	eax, [ebp+10h]
		add	eax, 0Eh
		mov	[esi+2], eax
		push	0Eh
		push	edi
		call	RtlZeroMemory
		mov	ecx, 0Eh
		rep movsb
		xor	eax, eax
		inc	al
		pop	edi
		pop	esi
		leave	
		retn	0Ch

; ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

COMMENT $

	$
